.text
 .p2align 4
 .globl exflib_float_imul_f90_
 .type exflib_float_imul_f90_, @function
exflib_float_imul_f90_:
 movl 4(%esp), %edx
 movl 8(%esp), %eax
 movl (%edx), %edx
 movl (%eax), %eax
 movl %edx, 4(%esp)
 movl %eax, 8(%esp)
 .globl exflib_float_imul_f77_
 .type exflib_float_imul_f77_, @function
exflib_float_imul_f77_:
 movl 12(%esp), %eax
 movl 20(%esp), %ecx
 movl 4(%eax), %edx
 movl 0(%eax), %eax
 movl 0(%ecx), %ecx
 movl %edx, 16(%esp)
 movl %eax, 12(%esp)
 movl %ecx, 20(%esp)
 .globl exflib_float_imul
 .type exflib_float_imul, @function
exflib_float_imul:
 movl 8(%esp), %eax
 movl 12(%esp), %ecx
 movl 16(%esp), %edx
 movl %ecx, 8(%esp)
 movl %edx, 12(%esp)
 movl 4(%esp), %ecx
 movl %eax, 4(%esp)
 movl %ecx, 16(%esp)
 movl 4(%eax), %ecx
 movl (%eax), %eax
 pushl %ebp
 pushl %ebx
 pushl %esi
 pushl %edi
 shll $1, %ecx
 orl %ecx, %eax
 jz .zero
 xorl %ecx, %ecx
 movl 24(%esp), %eax
 notl %ecx
 cmpl $0, %edx
 jne .check_negative
 btl $31, %eax
 jc .imul64
 cmpl $0, %eax
 je .zero
 jmp .imul32
.check_negative:
 cmpl %ecx, %edx
 jne .imul64
 btl $31, %eax
 jnc .imul64
 xorl %edx, %edx
 negl %eax
 btsl $31, %edx
.imul32:
 pushl %edx
 pushl %eax
 movl 44(%esp), %ecx
 movl 28(%esp), %esi
 movl 40(%esp), %edi
 cmpl $1, %eax
 je .imul32_noshift
 xorl %ebx, %ebx
.exflib_float_imul32_loop:
 movl (%esi, %ecx, 8), %eax
 movl (%esp), %edx
 mull %edx
 xorl %ebp, %ebp
 addl %eax, %ebx
 adcl %edx, %ebp
 movl 4(%esi, %ecx, 8), %eax
 movl (%esp), %edx
 movl %ebx, (%edi, %ecx, 8)
 mull %edx
 xorl %ebx, %ebx
 addl %eax, %ebp
 adcl %edx, %ebx
 movl %ebp, 4(%edi, %ecx, 8)
 decl %ecx
 jnz .exflib_float_imul32_loop
 nop
 movl 28(%esp), %esi
 movl 40(%esp), %edi
 movl (%esp), %ebp
 movl %ebx, %ecx
 movl (%esi), %ebx
 movl 4(%esi), %edx
 xorl %esi, %esi
 addl %ebp, %ecx
 movl 44(%esp), %ebp
 movl %ecx, %eax
 movl %ecx, (%edi)
 movl %esi, 4(%edi)
 movl $64, %ecx
 bsrl %eax, %esi
 subl %esi, %ecx
 movl (%edi, %ebp, 8), %eax
 movd %ecx, %mm1
 movd %esi, %mm0
 shll %cl, %eax
 movl 4(%esp), %ecx
 leal 8(%esp), %esp
.imul32_shift_mantissa:
 movq (%edi, %ebp, 8), %mm2
 movq -8(%edi, %ebp, 8), %mm3
 psrlq %mm0, %mm2
 psllq %mm1, %mm3
 por %mm3, %mm2
 movq %mm2, (%edi, %ebp, 8)
 decl %ebp
 jnz .imul32_shift_mantissa
 emms
.imul32_exponent:
 movl %edx, %ebp
 shll $1, %edx
 shrl $63, %ebp
 shrl $1, %edx
 shll $63, %ebp
 xorl %ecx, %ebp
 addl %esi, %ebx
 adcl $0, %edx
 btl $31, %edx
 jc .imul32_overflow
.imul32_ret:
 orl %ebp, %edx
 movl %ebx, (%edi)
 movl %edx, 4(%edi)
 popl %edi
 popl %esi
 popl %ebx
 popl %ebp
 ret
.imul32_overflow:
 xorl %edx, %edx
 xorl %ebx, %ebx
 notl %edx
 notl %ebx
 xorl %eax, %eax
 shrl $1, %edx
 jmp .imul32_ret
.imul32_noshift:
 movl (%esi), %ebx
 movl 4(%esi), %ebp
 movl %edi, %eax
 incl %ecx
 shll $1, %ecx
 cld
 rep movsl
 addl $8, %esp
 movl %eax, %edi
 xorl %ebp, %edx
 shrl $31, %edx
 shll $1, %ebp
 shll $31, %edx
 shrl $1, %ebp
 xorl %eax, %eax
 jmp .imul32_ret
.imul64:
 movl %eax, %ecx
 orl %edx, %eax
 jz .zero
 movl %ecx, %eax
 xorl %ecx, %ecx
 btl $31, %edx
 jnc .imul64_restoreB
 rcrl $1, %ecx
 notl %edx
 notl %eax
 addl $1, %eax
 adcl $0, %edx
.imul64_restoreB:
 pushl %ecx
 pushl %edx
 pushl %eax
 movl 48(%esp), %ecx
 movl 32(%esp), %ebp
 movl 44(%esp), %edi
 xorl %esi, %esi
 leal (%ebp, %ecx, 8), %ebp
 leal (%edi, %ecx, 8), %edi
 pushl %ecx
 xorl %ecx, %ecx
.exflib_float_imul64_loop:
 movl 4(%esp), %eax
 movl (%ebp), %edx
 xorl %ebx, %ebx
 cmpl $0, %eax
 je .exflib_float_imul64_p1
 mull %edx
 addl %eax, %esi
 adcl %edx, %ecx
 adcl $0, %ebx
 movl 4(%esp), %eax
 movl 4(%ebp), %edx
 mull %edx
 addl %eax, %ecx
 adcl %edx, %ebx
.exflib_float_imul64_p1:
 movl (%ebp), %edx
 movl %esi, (%edi)
 movl 8(%esp), %eax
 cmpl $0, %eax
 je .exflib_float_imul64_p2
 mull %edx
 xorl %esi, %esi
 addl %eax, %ecx
 adcl %edx, %ebx
 adcl $0, %esi
 movl 8(%esp), %eax
 movl 4(%ebp), %edx
 mull %edx
 movl %ecx, 4(%edi)
 leal -8(%ebp), %ebp
 leal -8(%edi), %edi
 addl %eax, %ebx
 adcl %edx, %esi
 popl %edx
.exflib_float_imul64_epilogue_loop:
 movl %esi, %ecx
 movl %ebx, %esi
 decl %edx
 pushl %edx
 jnz .exflib_float_imul64_loop
 addl $4, %esp
 movl 0(%esp), %eax
 movl 4(%esp), %edx
 addl %eax, %esi
 adcl %edx, %ecx
 movl 0(%ebp), %eax
 movl 4(%ebp), %edx
 movl 4(%ebp), %ebx
 movl %ecx, %ebp
 movl %esi, (%edi)
 movl %ecx, 4(%edi)
 movl 8(%esp), %ecx
 shll $1, %edx
 shrl $31, %ebx
 movl %eax, (%esp)
 shrl $1, %edx
 shll $31, %ebx
 xorl %ecx, %ebx
 movl %edx, 4(%esp)
 movl %ebx, 8(%esp)
 xorl %ecx, %ecx
 xorl %eax, %eax
 movl 48(%esp), %ebx
 cmpl $1, %ebp
 ja .imul64_shift_32bit_over
 je .imul64_shift_32bit
 cmpl $1, %esi
 je .imul64_exponent
 shrl $1, %esi
.imul64_shift_32bit_under:
 incl %ecx
 shrl $1, %esi
 jnz .imul64_shift_32bit_under
 movl (%edi, %ebx, 8), %eax
 movl $32, %ebp
 subl %ecx, %ebp
 xchgl %ecx, %ebp
 shll %cl, %eax
 addl $32, %ecx
 movd %ecx, %mm0
 movd %ebp, %mm1
 subl $32, %ecx
.imul64_shift_mantissa:
 movq (%edi, %ebx, 8), %mm2
 movq -8(%edi, %ebx, 8), %mm3
 psrlq %mm1, %mm2
 psllq %mm0, %mm3
 por %mm3, %mm2
 movq %mm2, (%edi, %ebx, 8)
 decl %ebx
 jnz .imul64_shift_mantissa
 xchgl %ecx, %ebp
 emms
.imul64_exponent:
 movl (%esp), %ebp
 movl 4(%esp), %edx
 addl %ecx, %ebp
 movl 8(%esp), %ecx
 adcl $0, %edx
 btl $31, %edx
 jc .imul64_overflow
 orl %ecx, %edx
 movl %ebp, (%edi)
 movl %edx, 4(%edi)
.imul64_restore:
 addl $12, %esp
 popl %edi
 popl %esi
 popl %ebx
 popl %ebp
 ret
.imul64_shift_32bit:
 movl $32, %ecx
 movl (%edi, %ebx, 8), %eax
.imul64_shift_32bit_loop:
 movl 4(%edi, %ebx, 8), %esi
 movl -8(%edi, %ebx, 8), %edx
 movl %esi, (%edi, %ebx, 8)
 movl %edx, 4(%edi, %ebx, 8)
 decl %ebx
 jnz .imul64_shift_32bit_loop
 jmp .imul64_exponent
.imul64_shift_32bit_over:
 bsrl %ebp, %ebp
 movl $32, %ecx
 subl %ebp, %ecx
 movd %ebp, %mm7
 addl $32, %ebp
 movl (%edi, %ebx, 8), %eax
 movq (%edi, %ebx, 8), %mm2
 shll %cl, %eax
 subl $1, %eax
 movl $0, %eax
 rcll $1, %eax
 xorl $1, %eax
 psrlq %mm7, %mm2
 movd %mm2, %edx
 orl %edx, %eax
 movd %ebp, %mm1
 movd %ecx, %mm0
 jmp .imul64_shift_mantissa
.imul64_overflow:
 xorl %eax, %eax
 notl %eax
 movl %eax, %edx
 shrl $1, %edx
 orl %ecx, %edx
 movl %edx, 4(%edi)
 movl %eax, (%edi)
 xorl %eax, %eax
 addl $12, %esp
 popl %edi
 popl %esi
 popl %ebx
 popl %ebp
 ret
.exflib_float_imul64_p2:
 movl %ecx, 4(%edi)
 xorl %esi, %esi
 popl %edx
 leal -8(%ebp), %ebp
 leal -8(%edi), %edi
 jmp .exflib_float_imul64_epilogue_loop
.zero:
 movl 20(%esp), %ecx
 movl 4(%ecx), %ecx
 xorl %ecx, %edx
 movl 32(%esp), %ecx
 xorl %eax, %eax
 shrl $31, %edx
 shll $31, %edx
 movl %eax, (%ecx)
 movl %edx, 4(%ecx)
 popl %edi
 popl %esi
 popl %ebx
 popl %ebp
 ret
        .ident "$Id: $"
