.ident "$Id: Time-stamp: \"2006-03-07 09:42:26 fujiwara\", array_idiv.S"
.text
 .p2align 4
.globl exflib_array_idiv_f77_
 .type exflib_array_idiv_f77_, @function
exflib_array_idiv_f77_:
 movq (%rdx), %rdx
 movq (%rcx), %rcx
.globl exflib_array_idiv
 .type exflib_array_idiv, @function
exflib_array_idiv:
 pushq %r12
 movq %rdx, %r10
 movq (%r8), %r12
 movq %rcx, %r11
 leaq (%rsi,%r12,8),%rsi
 leaq (%rdi,%r12,8),%r9
 subq %r12, %r11
 jle .dividend_is_zero
 cmpq $0, %r12
 je .divide
 movq %r12, %rcx
 xorq %rax, %rax
 cld
 rep stosq
 .p2align 4
.divide:
 movq %r11, %rcx
 xorq %rdx, %rdx
 movq %r9, %rdi
.divide_loop:
 movq (%rsi), %rax
 divq %r10
 movq %rax, (%rdi)
 leaq 8(%rsi), %rsi
 leaq 8(%rdi), %rdi
 decq %rcx
 jnz .divide_loop
 movq %rdx, %rax
 shlq $1, %rdx
 cmpq %rdx, %r10
 je .tie_break_rule
 jb .round_up
.finding_non_zero:
 movq (%r9), %r11
 cmpq $0, %r11
 jne .end
 incq (%r8)
.end:
 popq %r12
 ret
.tie_break_rule:
 btq $0, -8(%rdi)
 jnc .finding_non_zero
.round_up:
 movq -8(%rdi), %rdx
 addq $1, %rdx
 movq %rdx, -8(%rdi)
 leaq -8(%rdi), %rdi
 jc .round_up
 jmp .finding_non_zero
.dividend_is_zero:
 xorq %rax, %rax
 cld
 rep stosq
 popq %r12
 ret
