.ident "$Id: Time-stamp: \"2006-03-07 09:43:43 fujiwara\", array_mul_k.S $"
.text
 .p2align 4
.globl exflib_array_mul_k_f77_
 .type exflib_array_mul_k_f77_, @function
exflib_array_mul_k_f77_:
 movq (%rcx), %rcx
.globl exflib_array_mul_k
 .type exflib_array_mul_k, @function
exflib_array_mul_k:
 movq %rdi, %rax
 movq %rsi, %rdi
 movq %rdx, %rsi
 movq %rax, %rdx
 pushq %rbp
 pushq %rbx
 pushq %r12
 movq %rcx, %rax
 pushq %r13
 btq $0, %rax
 pushq %r14
 adcq $0, %rax
 pushq %r15
 pushq %rdx
 movq %rsp, %r15
 movq %rax, %r8
 movq %rsi, %rbx
 shlq $3, %r8
 movq %rdi, %rsi
 subq %rax, %r8
 shlq $3, %r8
 subq %r8, %rsp
 movq %rsp, %rdi
 movq %rcx, %rdx
 shrq $1, %rdx
 subq %rdx, %rcx
 xorq %rbp, %rbp
 .p2align 4
.ko00:
 pushq %rsi
 pushq %rbx
 pushq %rdi
 pushq %rcx
 pushq %rdx
 shlq $2, %rbp
 incq %rbp
 cmpq $40, %rcx
 jle .unit
 movq %rcx, %rdx
 shrq $1, %rdx
 subq %rdx, %rcx
 jmp .ko00
 .p2align 4
.ko01:
 pushq %rsi
 pushq %rbx
 pushq %rdi
 pushq %rcx
 pushq %rdx
 shlq $2, %rbp
 addq $2, %rbp
 leaq (%rsi, %rcx, 8), %rsi
 leaq (%rbx, %rcx, 8), %rbx
 shlq $1, %rcx
 leaq (%rdi, %rcx, 8), %rdi
 movq %rdx, %rcx
 cmpq $40, %rdx
 jle .unit
 shrq $1, %rdx
 subq %rdx, %rcx
 jmp .ko00
 .p2align 4
.ko10:
 pushq %rax
 pushq %rsi
 pushq %rbx
 pushq %rdi
 pushq %rcx
 pushq %rdx
 movq %rcx, %r8
 shlq $2, %rcx
 leaq (%rcx, %r8, 8), %rax
 addq %r8, %rax
 leaq -8(%rdi, %rax, 8), %rdi
 movq %r8, %rcx
 cmpq %r8, %rdx
 jne .ko10_diff_length
 leaq (%rbx, %rcx, 8), %r11
 leaq (%rsi, %rcx, 8), %rbx
 shlq $1, %rcx
 leaq -8(%rsi, %rcx, 8), %r12
 movq %r8, %rcx
.ko10_compare_ab:
 movq (%rsi), %rax
 movq (%rbx), %rdx
 leaq 8(%rsi), %rsi
 leaq 8(%rbx), %rbx
 cmpq %rax, %rdx
 jb .ko10_a_greater
 ja .ko10_b_greater
 # loop .ko10_compare_ab
 decq %rcx
 jnz .ko10_compare_ab
.ko10_a_greater:
 movq 32(%rsp), %rsi
 movq %r8, %rcx
 xorq %rax, %rax
 movq %r12, %rbx
 leaq -8(%rsi, %r8, 8), %rsi
 movq %rax, %r9
 clc
 jmp .ko10_sub_A
.ko10_b_greater:
 movq 32(%rsp), %rsi
 xorq %rax, %rax
 movq %r8, %rcx
 notq %rax
 leaq -8(%rsi, %r8, 8), %rbx
 movq %r12, %rsi
 movq %rax, %r9
 clc
 .p2align 4
.ko10_sub_A:
 movq (%rsi), %rax
 movq (%rbx), %rdx
 leaq -8(%rsi), %rsi
 leaq -8(%rbx), %rbx
 sbbq %rdx, %rax
 movq %rax, (%rdi)
 leaq -8(%rdi), %rdi
 # loop .ko10_sub_A
 decq %rcx
 jnz .ko10_sub_A
 movq 24(%rsp), %rsi
 movq %r8, %rcx
 shlq $1, %rcx
 leaq (%rdi, %rcx, 8), %rdi
 movq %r11, %rbx
 movq %r8, %rcx
 leaq -8(%r11, %r8, 8), %r13
.ko10_compare_cd:
 movq (%rsi), %rax
 movq (%rbx), %rdx
 leaq 8(%rsi), %rsi
 leaq 8(%rbx), %rbx
 cmpq %rax, %rdx
 jb .c_greater
 ja .d_greater
 #loop .ko10_compare_cd
 decq %rcx
 jnz .ko10_compare_cd
.c_greater:
 movq 24(%rsp), %rsi
 xorq %rax, %rax
 movq %r8, %rcx
 xorq %rax, %r9
 movq %r13, %rbx
 leaq -8(%rsi, %rcx, 8), %rsi
 clc
 jmp .ko10_sub_B
.d_greater:
 movq 24(%rsp), %rsi
 xorq %rax, %rax
 movq %r8, %rcx
 notq %rax
 leaq -8(%rsi, %rcx, 8), %rbx
 movq %r13, %rsi
 xorq %rax, %r9
 clc
 .p2align 4
.ko10_sub_B:
 movq (%rsi), %rax
 movq (%rbx), %rdx
 leaq -8(%rsi), %rsi
 leaq -8(%rbx), %rbx
 sbbq %rdx, %rax
 movq %rax, (%rdi)
 leaq -8(%rdi), %rdi
 #loop .ko10_sub_B
 decq %rcx
 jnz .ko10_sub_B
.ko10_next:
 movq 16(%rsp), %rdi
 movq %r8, %rdx
 movq %r8, %rcx
 shlq $2, %rdx
 movq %r9, 40(%rsp)
 leaq (%rdx, %rcx, 8), %rax
 shlq $2, %rbp
 leaq (%rdi, %rax, 8), %rsi
 leaq (%rdi, %rdx, 8), %rdi
 leaq (%rsi, %rcx, 8), %rbx
 movq %rcx, %rdx
 addq $3, %rbp
 cmpq $40, %rcx
 jle .unit
 shrq $1, %rdx
 subq %rdx, %rcx
 jmp .ko00
 .p2align 4
.ko10_diff_length:
 movq %rdi, %rdx
 movq %rdi, %r12
 movq 16(%rsp), %rdi
 subq %r8, %rax
 leaq (%rdi, %rax, 8), %rbx
 movq %rsi, %rax
 leaq (%rsi, %r8, 8), %rsi
 movq $0, (%rbx)
 decq %rcx
 leaq 8(%rbx), %rdi
 cld
 rep movsq
 leaq 8(%rdx), %rdi
 movq 24(%rsp), %rsi
 movq $0, (%rdi)
 movq %r8, %rcx
 movq %rdi, %r11
 leaq 8(%rdi), %rdi
 leaq (%rsi, %rcx, 8), %rsi
 decq %rcx
 cld
 rep movsq
 movq %rdx, %rdi
 movq %rax, %rsi
 movq %r8, %rcx
 jmp .ko10_compare_ab
 .p2align 4
.ko11:
 popq %r12
 movq %rdx, %r8
 movq %rcx, %r9
 movq %rdi, %r10
 shlq $1, %rcx
 shlq $1, %rdx
 leaq (%rdi, %rcx, 8), %rdi
 leaq -8(%rdi, %rdx, 8), %rsi
 shlq $1, %rcx
 leaq (%rdi, %rcx, 8), %rdi
 xorq %rax, %rax
 movq %rax, (%rdi)
 movq %rax, 8(%rdi)
 shrq $1, %rcx
 leaq -8(%rdi, %rcx, 8), %rdi
 movq %rdx, %rcx
 std
 rep movsq
 cld
 movq %r9, %rcx
 shlq $1, %rcx
 leaq (%rcx, %r9, 4), %rax
 leaq -8(%r10, %rcx, 8), %rsi
 leaq (%rsi, %r8, 8), %rdi
 leaq (%rsi, %rax, 8), %rbx
 xorq %rax, %rax
 .p2align 4
.ko11_loop1:
 xorq %rdx, %rdx
 movq (%rdi), %r11
 leaq -8(%rdi), %rdi
 addq %r11, %rax
 adcq $0, %rdx
 movq (%rsi), %r11
 leaq -8(%rsi), %rsi
 addq %r11, %rax
 adcq $0, %rdx
 movq (%rbx), %r11
 leaq -8(%rbx), %rbx
 addq %r11, %rax
 adcq $0, %rdx
 movq %rax, 8(%rdi)
 movq %rdx, %rax
 # loop .ko11_loop1
 decq %rcx
 jnz .ko11_loop1
 movq %rax, %rbx
 movq %r9, %rcx
 shlq $1, %rcx
 leaq -8(%r10, %rcx, 8), %rdi
 shlq $1, %rcx
 leaq (%rdi, %rcx, 8), %rsi
 leaq (%rdi, %r8, 8), %rdi
 shrq $1, %rcx
 cmpq $0, %r12
 jne .ko11_add_start
 clc
.ko11_sub:
 movq (%rsi), %rdx
 movq (%rdi), %rax
 leaq -8(%rsi), %rsi
 leaq -8(%rdi), %rdi
 sbbq %rdx, %rax
 movq %rax, 8(%rdi)
 # loop .ko11_sub
 decq %rcx
 jnz .ko11_sub
 movq (%rdi), %rax
 sbbq $0, %rbx
.ko11_carry:
 adcq %rbx, %rax
 movq %rax, (%rdi)
 jc .ko11_carry_out
.ko11_next:
 cmpq $0, %rbp
 je .exit_karatsuba
 popq %rdx
 popq %rcx
 popq %rdi
 popq %rbx
 popq %rsi
 movq %rbp, %rax
 andq $3, %rax
 shrq $2, %rbp
 cmpq $2, %rax
 jl .ko01
 je .ko10
 jmp .ko11
.ko11_add_start:
 clc
.ko11_add:
 movq (%rsi), %rdx
 movq (%rdi), %rax
 leaq -8(%rsi), %rsi
 leaq -8(%rdi), %rdi
 adcq %rdx, %rax
 movq %rax, 8(%rdi)
 # loop .ko11_add
 decq %rcx
 jnz .ko11_add
 movq (%rdi), %rax
 adcq $0, %rbx
 jmp .ko11_carry
.ko11_carry_out:
 adcq $0, -8(%rdi)
 leaq -8(%rdi), %rdi
 jnc .ko11_next
 jmp .ko11_carry_out
.unit:
 leaq -8(%rsi, %rcx, 8), %r9
 leaq (%rbx, %rcx, 8), %r10
 movq %rcx, %r11
 shlq $1, %rcx
 leaq -8(%rdi, %rcx, 8), %r14
 subq $2, %rcx
 movq %rcx, %r13
 xorq %rdi, %rdi
 xorq %rsi, %rsi
 xorq %rbx, %rbx
.mpy_full_outloop:
 movq %r11, %rcx
 decq %rcx
 cmpq %rcx, %r13
 jl .mpy_full_s
.mpy_full_g:
 leaq -8(%r10), %r10
 movq %r10, %r8
 movq %r9, %r12
 shlq $1, %rcx
 subq %r13, %rcx
 incq %rcx
 jmp .mpy_full_inloop
.mpy_full_s:
 leaq -8(%r9), %r9
 movq %r9, %r12
 movq %r10, %r8
 movq %r13, %rcx
 incq %rcx
 .p2align 4
.mpy_full_inloop:
 movq (%r12), %rax
 movq (%r8), %rdx
 mulq %rdx
 leaq -8(%r12), %r12
 leaq 8(%r8), %r8
 addq %rax, %rdi
 adcq %rdx, %rsi
 adcq $0, %rbx
 decq %rcx
 jnz .mpy_full_inloop
.mpy_full_inloop_end:
 movq %rdi, (%r14)
 movq %rsi, %rdi
 leaq -8(%r14), %r14
 movq %rbx, %rsi
 xorq %rbx, %rbx
 decq %r13
 jns .mpy_full_outloop
 movq %rdi, (%r14)
 popq %rdx
 popq %rcx
 popq %rdi
 popq %rbx
 popq %rsi
 movq %rbp, %rax
 andq $3, %rax
 shrq $2, %rbp
 cmpq $2, %rax
 jl .ko01
 je .ko10
 jmp .ko11
.exit_karatsuba:
 movq %r10, %rsi
 movq (%r15), %rdi
 addq %r8, %r9
 movq %r9, %rcx
 movq 8(%rsi, %r9, 8), %rdx
 xorq %rax, %rax
 stc
 rcrq $1, %rax
 cmpq %rax, %rdx
 ja .exflib_array_mul_k_roundup
 je .exflib_array_mul_k_sticky
.exflib_array_mul_k_chop:
 addq $8, %rsi
 cld
 rep movsq
.exflib_array_mul_k_end:
 leaq 8(%r15), %rsp
 movq (%r10), %rax
 popq %r15
 popq %r14
 popq %r13
 popq %r12
 popq %rbx
 popq %rbp
 ret
.exflib_array_mul_k_roundup:
 leaq (%rsi, %rcx, 8), %rsi
 leaq -8(%rdi, %rcx, 8), %rdi
 stc
.exflib_array_mul_k_rounduploop:
 movq (%rsi), %rax
 leaq -8(%rsi), %rsi
 adcq $0, %rax
 movq %rax, (%rdi)
 leaq -8(%rdi), %rdi
 decq %rcx
 jc .exflib_array_mul_k_rounduploop
 jz .exflib_array_mul_k_end
 std
 rep movsq
 cld
 jmp .exflib_array_mul_k_end
.exflib_array_mul_k_sticky:
 xorq %rax, %rax
 movq %rcx, %rdx
 leaq 16(%rsi, %rcx, 8), %rbx
 subq $2, %rdx
.exflib_array_mul_k_checkstkicky:
 orq (%rbx), %rax
 leaq 8(%rbx), %rbx
 decq %rdx
 jnz .exflib_array_mul_k_checkstkicky
 cmpq $0, %rax
 jne .exflib_array_mul_k_roundup
 movq (%rsi, %rcx, 8), %rax
 btq $0, %rax
 jc .exflib_array_mul_k_roundup
 jmp .exflib_array_mul_k_chop
