.ident "$Id: Time-stamp: \"2006-03-07 09:44:49 fujiwara\", float_div.S $"
.text
 .p2align 4
.globl exflib_float_div_f90_
 .type exflib_float_div_f90_, @function
exflib_float_div_f90_:
 movq (%rdi), %rdi
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_div_f77_
 .type exflib_float_div_f77_, @function
exflib_float_div_f77_:
 movq (%rcx), %rcx
.globl exflib_float_div
 .type exflib_float_div, @function
exflib_float_div:
 movq (%rsi), %r10
 movq (%rdx), %r11
 movq 8(%rdx), %r8
 movq 8(%rdx), %r9
 movq %rdi, %rax
 movq %rsi, %rdi
 movq %rdx, %rsi
 movq %rax, %rdx
 pushq %rbp
 pushq %rbx
 pushq %rdx
 pushq %r10
 pushq %r11
 shlq $1, %r11
 jz .infty
 addq $2, %r11
 jc .infty
 shlq $1, %r10
 jz .zero
 addq $2, %r10
 jc .infty
 addq $2, %r9
 movq %rcx, %rbp
 jc .non_predication
 xorq %rdx, %rdx
 shrq $1, %r8
 xorq %rax, %rax
 btsq $63, %r8
 btsq $63, %rdx
 incq %r8
 divq %r8
.stack:
 shlq $4, %rcx
 xorq %r9, %r9
 addq $40, %rcx
 subq %rcx, %rsp
 movq %rbp, %rcx
 movq %r9, 8(%rsp, %rbp, 8)
 movq %r9, 16(%rsp, %rbp, 8)
 movq %rbp, %r8
.compareAB:
 movq 8(%rdi, %r9, 8), %r10
 movq 8(%rsi, %r9, 8), %r11
 incq %r9
 cmpq %r11, %r10
 ja .subtractB
 jb .storeA
 decq %rcx
 jnz .compareAB
 shlq $4, %r8
 movq %rbp, %rcx
 movq (%rdi), %r10
 movq (%rsi), %r11
 addq $64, %r8
 movq %rbp, %rcx
 addq %r8, %rsp
 movq -8(%rsp), %rdx
 xorq %rax, %rax
 movq %rdx, %rdi
 addq $8, %rdi
 cld
 rep stosq
.exponent:
 movq %r10, %r8
 movq %r11, %r9
 xorq %r11, %r10
 xorq %r11, %r11
 btrq $63, %r8
 notq %r11
 btrq $63, %r9
 shrq $2, %r11
 subq %r9, %r8
 cmpq %r11, %r8
 jg .overflow
 movq %r11, %r9
 negq %r9
 cmpq %r9, %r8
 jle .underflow
 addq %r11, %r8
.sign:
 shlq $1, %r8
 btq $63, %r10
 rcrq $1, %r8
 movq %r8, (%rdx)
 popq %rbx
 popq %rbp
 ret
.overflow:
 xorq %r8, %r8
 xorq %rax, %rax
 notq %r8
 jmp .sign
.underflow:
 xorq %rax, %rax
 xorq %r8, %r8
 incq %rax
 jmp .sign
.infty:
 popq %r11
 popq %r10
 addq $8, %rsp
 xorq %r8, %r8
 notq %r8
 xorq %rax, %rax
 xorq %r11, %r10
 jmp .sign
.zero:
 popq %r11
 popq %r10
 addq $8, %rsp
 xorq %r8, %r8
 xorq %rax, %rax
 xorq %r11, %r10
 jmp .sign
.non_predication:
 xorq %rax, %rax
 btsq $63, %rax
 jmp .stack
.subtractB:
 movq (%rdi, %r8, 8), %r10
 movq (%rsi, %r8, 8), %r11
 sbbq %r11, %r10
 decq %r8
 movq %r10, 8(%rsp, %r8, 8)
 jnz .subtractB
 movq %r8, (%rsp)
 incq %r8
 movq %r8, 24(%rsp, %rbp, 8)
 jmp .division
.storeA:
 movq %rbp, %rcx
 movq %rsi, %r10
 movq %rdi, %rsi
 movq %rsp, %rdi
 addq $8, %rsi
 addq $8, %rdi
 cld
 rep movsq
 xorq %rcx, %rcx
 movq %r10, %rsi
 movq %rcx, 24(%rsp, %rbp, 8)
 incq %rcx
 movq %rcx, (%rsp)
.division:
 movq %rbp, %rdi
 movq %rax, %rbx
 incq %rdi
.predicate:
 movq (%rsp), %rax
 movq 8(%rsp), %r8
 mulq %rbx
 xchgq %r8, %rax
 mulq %rbx
 addq %rdx, %r8
 movq %rdi, %rcx
 cmpq %rbp, %rdi
 cmova %rbp, %rcx
 xorq %r9, %r9
 xorq %r10, %r10
.residual:
 movq (%rsi, %rcx, 8), %rax
 movq 8(%rsp, %rcx, 8), %r11
 mulq %r8
 addq %r9, %rax
 adcq $0, %rdx
 xorq %r9, %r9
 subq %rax, %r11
 adcq $0, %r9
 subq %r10, %r11
 adcq $0, %r9
 movq %r9, %r10
 movq %r11, 8(%rsp, %rcx, 8)
 movq %rdx, %r9
 decq %rcx
 jnz .residual
 movq %r8, %rax
 movq 8(%rsp), %r11
 movq (%rsp), %rdx
 addq %r9, %rax
 adcq $0, %rcx
 addq %r10, %rax
 adcq $0, %rcx
 subq %rax, %r11
 sbbq %rcx, %rdx
 movq %r11, 8(%rsp)
 movq %rdx, (%rsp)
 addq $8, %rsp
.check:
 cmpq $1, 0(%rsp)
 jb .epilogue
 ja .correct
 movq %rdi, %rcx
 cmpq %rbp, %rdi
 cmova %rbp, %rcx
 xorq %r9, %r9
.compareRB:
 movq 8(%rsp, %r9, 8), %rax
 movq 8(%rsi, %r9, 8), %rdx
 incq %r9
 cmpq %rdx, %rax
 ja .correct
 jb .epilogue
 decq %rcx
 jnz .compareRB
.correct:
 incq %r8
 movq %rdi, %rcx
 cmpq %rbp, %rdi
 cmova %rbp, %rcx
 clc
.new_residual:
 movq (%rsp, %rcx, 8), %rax
 movq (%rsi, %rcx, 8), %rdx
 sbbq %rdx, %rax
 movq %rax, (%rsp, %rcx, 8)
 decq %rcx
 jnz .new_residual
 incq %rcx
 sbbq %rcx, (%rsp)
 jmp .check
.epilogue:
 movq %r8, 24(%rsp, %rbp, 8)
 decq %rdi
 jnz .predicate
 movq 16(%rsp), %rdx
 addq $16, %rsp
 movq 24(%rsp, %rbp, 8), %r10
 movq 16(%rsp, %rbp, 8), %r11
 movq 32(%rsp, %rbp, 8), %rdi
 movq 8(%rsp, %rbp, 8), %rax
 movq %rsp, %rsi
 movq %rbp, %rcx
 cmpq $0, %rdx
 je .shift_quotient
 movq %rdi, %rbx
 addq $8, %rsi
 addq $8, %rdi
 cld
 rep movsq
 movq %rbx, %rdi
 jmp .end
.shift_quotient:
 shlq $1, %rax
 decq %r10
.shift:
 movq (%rsi, %rcx, 8), %rbx
 rclq $1, %rbx
 decq %rcx
 movq %rbx, 8(%rdi, %rcx, 8)
 jnz .shift
.end:
 leaq 40(%rsp, %rbp, 8), %rsp
 xorq %rdx, %rdx
 xorq %rcx, %rcx
 btsq $33, %rdx
 notq %rcx
 addq %rdx, %rax
 cmovc %rcx, %rax
 movq %rdi, %rdx
 jmp .exponent
