.ident "$Id: Time-stamp: \"2006-03-07 09:45:00 fujiwara\", float_idiv.S $"
.text
 .p2align 4
.globl exflib_float_idiv_f90_
 .type exflib_float_idiv_f90_, @function
exflib_float_idiv_f90_:
 movq (%rdi), %rdi
 movq (%rsi), %rsi
.globl exflib_float_idiv_f77_
 .type exflib_float_idiv_f77_, @function
exflib_float_idiv_f77_:
 movq (%rdx), %rdx
 movq (%rcx), %rcx
.globl exflib_float_idiv
 .type exflib_float_idiv, @function
exflib_float_idiv:
 movq %rdi, %rax
 movq %rsi, %rdi
 movq %rdx, %rsi
 movq %rax, %rdx
 pushq %rbp
 pushq %rbx
 movq %rdx, %r8
 movq %rdx, %rbp
 movq (%rdi), %rbx
 xorq %r9, %r9
 btq $63, %rsi
 jc .negateB
.check_AB:
 xorq %rbx, %r9
 movq %rcx, %r11
 shlq $1, %rbx
 shrq $63, %r9
 shrq $1, %rbx
 jz .zero
 movq $1, %rdx
 shlq $63, %r9
 cmpq $1, %rsi
 je .nodiv
.idiv64:
 movq 8(%rdi), %rax
 divq %rsi
 addq $8, %rdi
 addq $8, %r8
 movq %rax, -8(%r8)
 decq %rcx
 jnz .idiv64
 xorq %rax, %rax
 divq %rsi
 movq %rax, (%r8)
 movq (%rbp), %r10
 movq %r11, %rcx
 cmpq $1, %r10
 je .noshift
 bsrq %r10, %r8
 movq $64, %r10
 subq %r8, %r10
 movd %r8, %mm0
 movd %r10, %mm1
.shift_mantissa:
 movq (%rbp, %rcx, 8), %mm2
 movq -8(%rbp, %rcx, 8), %mm3
 psrlq %mm0, %mm2
 psllq %mm1, %mm3
 por %mm3, %mm2
 movq %mm2, (%rbp, %rcx, 8)
 decq %rcx
 jnz .shift_mantissa
 movq %r10, %rcx
 shlq %cl, %rax
.sticky:
 subq $1, %rdx
 movq $0, %rdx
 rclq $1, %rdx
 xorq $1, %rdx
 orq %rdx, %rax
 subq %r10, %rbx
 jc .underflow
 orq %r9, %rbx
 movq %rbx, (%rbp)
 popq %rbx
 popq %rbp
 ret
.negateB:
 rcrq $1, %r9
 notq %rsi
 incq %rsi
 jmp .check_AB
.nodiv:
 orq %r9, %rbx
 movq %rbx, (%rbp)
 leaq 8(%rdi), %rsi
 leaq 8(%rbp), %rdi
 xorq %rax, %rax
 cld
 rep movsq
 popq %rbx
 popq %rbp
 ret
.noshift:
 movq $64, %r10
 xorq %rax, %rax
 divq %rsi
 jmp .sticky
.underflow:
 movq %r9, (%rbp)
 movq $1, %rax
 popq %rbx
 popq %rbp
 ret
.zero:
 shlq $63, %r9
 movq %r9, (%rbp)
 xorq %rax, %rax
 popq %rbx
 popq %rbp
 ret
