.ident "$Id: Time-stamp: \"2006-03-07 09:47:24 fujiwara\", float_round.S $"
.text
 .p2align 4
.globl exflib_float_round_chop_f90_
 .type exflib_float_round_chop_f90_, @function
exflib_float_round_chop_f90_:
.globl exflib_float_round_chop_f77_
 .type exflib_float_round_chop_f77_, @function
exflib_float_round_chop_f77_:
 ret
.globl exflib_float_round_chop
 .type exflib_float_round_chop, @function
exflib_float_round_chop:
 ret
 .p2align 4
.globl exflib_float_round_plus_f90_
 .type exflib_float_round_plus_f90_, @function
exflib_float_round_plus_f90_:
 movq (%rdi), %rdi
.globl exflib_float_round_plus_f77_
 .type exflib_float_round_plus_f77_, @function
exflib_float_round_plus_f77_:
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_round_plus
 .type exflib_float_round_plus, @function
exflib_float_round_plus:
 movq (%rdi), %rax
 movq $1, %r11
 cmpq $0, %rsi
 je .exflib_float_round_end
 movq $2, %r8
  incq %rsi
 cmovz %r8, %r11
 btq $63, %rax
 jc .exflib_float_round_end
.exflib_float_round_up:
 movq %rax, %r8
 shlq $1, %rax
 jz .exflib_float_round_zero
 addq %r11, (%rdi, %rdx, 8)
 jc .exflib_float_round_up_loop
 ret
.exflib_float_round_up_loop:
 decq %rdx
 jz .exflib_float_round_up_exp
 adcq $0, (%rdi, %rdx, 8)
 jc .exflib_float_round_up_loop
 ret
.exflib_float_round_up_exp:
 movq (%rdi), %rax
 movq (%rdi), %rdx
 addq $1, %rax
 xorq %rax, %rdx
 js .exflib_float_round_overflow
 movq %rax, (%rdi)
.exflib_float_round_end:
 ret
.exflib_float_round_overflow:
 xorq %rax, %rax
 notq %rax
 shrq $1, %rax
 orq %rax, (%rdi)
 ret
 .p2align 4
.globl exflib_float_round_minus_f90_
 .type exflib_float_round_minus_f90_, @function
exflib_float_round_minus_f90_:
 movq (%rdi), %rdi
.globl exflib_float_round_minus_f77_
 .type exflib_float_round_minus_f77_, @function
exflib_float_round_minus_f77_:
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_round_minus
 .type exflib_float_round_minus, @function
exflib_float_round_minus:
 movq (%rdi), %rax
 movq $1, %r11
 cmpq $0, %rsi
 je .exflib_float_round_end
 movq $2, %r8
 incq %rsi
 cmovz %r8, %r11
 btq $63, %rax
 jc .exflib_float_round_up
 ret
 .p2align 4
.globl exflib_float_round_near_f90_
 .type exflib_float_round_near_f90_, @function
exflib_float_round_near_f90_:
 movq (%rdi), %rdi
.globl exflib_float_round_near_f77_
 .type exflib_float_round_near_f77_, @function
exflib_float_round_near_f77_:
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_round_near
 .type exflib_float_round_near, @function
exflib_float_round_near:
 movq (%rdi, %rdx, 8), %r9
 movq (%rdi), %rax
 movq $1, %r11
 xorq %rcx, %rcx
 btsq $63, %rcx
 cmpq %rcx, %rsi
 je .exflib_float_round_tiebreak
 ja .exflib_float_round_up
 ret
.exflib_float_round_tiebreak:
 btq $0, %r9
 jc .exflib_float_round_up
 ret
.exflib_float_round_zero:
 incq %r8
 decq %r11
 movq %r8, (%rdi)
 movq %r11, (%rdi, %rdx, 8)
 movq %rdx, %rcx
 addq $8, %rdi
 decq %rcx
 rep stosq
 ret
