/* -*- C -*- */
/* Time-stamp: "2006-04-17 10:39:39 fujiwara" */

/**********************************************************************/
/*  Copyright (C) 2005, FUJIWARA Hiroshi                              */
/*        <fujiwara@acs.i.kyoto-u.ac.jp>                              */
/**********************************************************************/

#include <stdio.h>

#if 0

/* obsoleted 2006-04-17 */

void exflib_version(){
    printf("Compiled at %s %s\n", __DATE__, __TIME__);
    return;
}

#else

/* C */

const char *exflib_version(){
    static char mess[128];
    sprintf(mess, "compiled at %s %s", __DATE__, __TIME__);
    return mess;
}

/* Fortran */
void exflib_trim_c_null(char *str);

void exflib_compiled_date_(char *mess){
    sprintf(mess, "compiled at %s %s", __DATE__, __TIME__);
    exflib_trim_c_null(mess);
    return;
}

void exflib_compiled_date__(char *mess){
    sprintf(mess, "compiled at %s %s", __DATE__, __TIME__);
    exflib_trim_c_null(mess);
    return;
}

#endif
/* End of version.c */
