// -*- C++ -*-
// $Id: pi.cpp,v 1.1.1.1 2002/04/07 07:18:10 fujiwara Exp $

#include <iostream>

#define PRECISION 1000
#include "exfloat.h"

using namespace std;

int main()
{
    exfloat pi, term, old_pi;
    long i, sign;

    term = 5;
    old_pi = 1;
    pi = 0;

    for(i = 1, sign = 1; pi != old_pi; i += 2, sign *= -1){
	term /= 25;
	old_pi = pi;
	pi += sign*(term/i);
    }

    pi *= 4;

    term = 239;
    old_pi = 1;
   
    for(i = 1, sign = -1; pi != old_pi; i += 2, sign *= -1){
	term /= 239*239;
	old_pi = pi;
	pi += sign*(term/i);
    }

    pi *= 4;

    cout << setiosflags(ios::scientific) << setprecision(1000) << pi << endl;

    cout.unsetf(ios::floatfield);
    cout << setiosflags(ios::fixed) << setprecision(1000) << pi << endl;
    cout << setiosflags(ios::fixed) << setprecision(100) << pi << endl;

    return 0;
}

// Local Variables:
// compile-command: "g++ -Wall -O2 -L.. -o pi pi.cpp -lexf"
// End:
