.data
.const:
 .long 0x00000000, 0x3df00000
 .long 0x00000000, 0x3ab00000
 .long 0x00000000, 0x3ff00000
.text
 .align 4
 .globl exflib_float_div_f90_
 .type exflib_float_div_f90_, @function
exflib_float_div_f90_:
 movl 4(%esp), %eax
 movl 8(%esp), %edx
 movl 12(%esp), %ecx
 movl (%eax), %eax
 movl (%edx), %edx
 movl (%ecx), %ecx
 movl %eax, 4(%esp)
 movl %edx, 8(%esp)
 movl %ecx, 12(%esp)
 .globl exflib_float_div_f77_
 .type exflib_float_div_f77_, @function
exflib_float_div_f77_:
 movl 16(%esp), %eax
 movl (%eax), %eax
 movl %eax, 16(%esp)
 .globl exflib_float_div
 .type exflib_float_div, @function
exflib_float_div:
 movl 4(%esp), %eax
 movl 8(%esp), %ecx
 movl 12(%esp), %edx
 movl %eax, 12(%esp)
 movl %ecx, 4(%esp)
 movl %edx, 8(%esp)
 pushl %ebp
 movl %esp, %ebp
 subl $32, %esp
 movl 12(%ebp), %eax
 movl $.const, %edx
 movl 20(%ebp), %ecx
 pushl %ebx
 pushl %edi
 pushl %esi
 movq 8(%eax), %mm0
 movq 0(%edx), %mm1
 psrlq $12, %mm0
 incl %ecx
 por %mm1, %mm0
 incl %ecx
 movq %mm0, -8(%ebp)
 shll $3, %ecx
 emms
 fldl 16(%edx)
 fldl 8(%edx)
 fldl -8(%ebp)
 subl %ecx, %esp
 faddp
 movl %esp, %edi
 movl $0, -32(%ebp)
 subl %ecx, %esp
 movl 8(%ebp), %eax
 movl 12(%ebp), %ebx
 movl 20(%ebp), %ecx
 movl $1, 4(%esp)
 movl $1, 4(%edi)
 movl $0, -8(%edi)
 movl $0, -4(%edi)
 movl $0, -52(%ebp)
 movl $0, -48(%ebp)
 fstcw -20(%ebp)
 movw -20(%ebp), %dx
 orw $0xc00, %dx
 movw %dx, -18(%ebp)
 fldcw -18(%ebp)
 fdivrp
.stack_copy:
 movl (%ebx, %ecx, 8), %esi
 movl (%eax, %ecx, 8), %edx
 movl %esi, 4(%esp, %ecx, 8)
 orl %esi, -32(%ebp)
 movl %edx, 4(%edi, %ecx, 8)
 movl 4(%ebx, %ecx, 8), %esi
 movl 4(%eax, %ecx, 8), %edx
 movl %esi, (%esp, %ecx, 8)
 orl %esi, -32(%ebp)
 movl %edx, (%edi, %ecx, 8)
 decl %ecx
 jnz .stack_copy
 cmpl $0, -32(%ebp)
 je .store_A
 addl $4, %esp
 addl $4, %edi
 fstl -8(%ebp)
 fldcw -20(%ebp)
 movl $2, -24(%ebp)
 movl 20(%ebp), %ecx
 leal 4(%esp), %ebx
 leal 4(%edi), %eax
 shll $1, %ecx
.integer_loop:
 movl (%ebx), %edx
 addl $4, %eax
 addl $4, %ebx
 cmpl %edx, -4(%eax)
 ja .quotient_is_one
 jb .quotient_is_zero
 decl %ecx
 jnz .integer_loop
 movl 20(%ebp), %ecx
 xorl %eax, %eax
 movl 16(%ebp), %edi
 shll $1, %ecx
 addl $8, %edi
 cld
 rep stosl
 movl $0, -16(%ebp)
 movl $0, -28(%ebp)
.exponent:
 movl 8(%ebp), %esi
 movl 12(%ebp), %edi
 movl 0(%esi), %eax
 movl 4(%esi), %ebx
 movl 0(%edi), %ecx
 movl 4(%edi), %edx
 andl $0x7fffffff, %ebx
 andl $0x7fffffff, %edx
 rcrl $1, -28(%ebp)
 movl 4(%esi), %esi
 movl 4(%edi), %edi
 sbbl %ecx, %eax
 sbbl %edx, %ebx
 movl %ebx, %edx
 movl 16(%ebp), %ecx
 xorl %esi, %edi
 addl $0xffffffff, %eax
 adcl $0x3fffffff, %ebx
 andl $0x80000000, %edi
 btl $31, %ebx
 jc .out_of_range
 orl %ebx, %edi
.stack:
 movl %eax, (%ecx)
 movl %edi, 4(%ecx)
 movl -16(%ebp), %eax
 leal -44(%ebp), %esp
 popl %esi
 popl %edi
 popl %ebx
 movl %ebp, %esp
 popl %ebp
 ret
.out_of_range:
 xorl %eax, %eax
 btl $31, %edx
 movl $0, -16(%ebp)
 jc .stack
 orl $0x7fffffff, %edi
 notl %eax
 jmp .stack
.quotient_is_zero:
 movl 20(%ebp), %eax
 movl 16(%ebp), %esi
 incl %eax
 movl $1, -28(%ebp)
 shll $1, %eax
 movl %eax, -20(%ebp)
 jmp .ozawa
.quotient_is_one:
 movl 20(%ebp), %ecx
 movl 16(%ebp), %esi
 movl 20(%ebp), %edx
 shll $1, %ecx
 incl %edx
 clc
.sub_loop:
 movl (%esp, %ecx, 4), %eax
 sbbl %eax, (%edi, %ecx, 4)
 decl %ecx
 jns .sub_loop
 shll $1, %edx
 movl $0, -28(%ebp)
 movl %edx, -20(%ebp)
.ozawa:
 movd 4(%edi), %mm1
 movd 8(%edi), %mm0
 cmpl $0, (%edi)
 je .q0
 movl $.const, %edx
 punpckldq %mm1, %mm0
 movq 16(%edx), %mm1
 psrlq $12, %mm0
 por %mm1, %mm0
 movq %mm0, -16(%ebp)
 emms
 jmp .q1
.q0:
 cmpl $0, 4(%edi)
 je .q2
 bsrl 4(%edi), %ecx
 punpckldq %mm1, %mm0
 movl $32, %edx
 subl %ecx, %edx
 movd %edx, %mm2
 addl $0x3df, %ecx
 psllq %mm2, %mm0
 movd %ecx, %mm3
 psrlq $12, %mm0
 psllq $52, %mm3
 por %mm3, %mm0
 movq %mm0, -16(%ebp)
 emms
.q1:
 fldl -8(%ebp)
 fldl -16(%ebp)
 fstcw -32(%ebp)
 movw -32(%ebp), %ax
 orw $0xc00, %ax
 movw %ax, -30(%ebp)
 fldcw -30(%ebp)
 fmulp
 movl -20(%ebp), %ecx
 fistpll -16(%ebp)
 fldcw -32(%ebp)
 cmpl $2, %ecx
 je .end
.subtract_loop:
 movl -4(%esp, %ecx, 4), %eax
 mull -16(%ebp)
 subl %eax, (%edi, %ecx, 4)
 sbbl %edx, -4(%edi, %ecx, 4)
 movl %ecx, %ebx
 jnc .nocarry
.carry:
 subl $1, -8(%edi, %ebx, 4)
 decl %ebx
 jc .carry
.nocarry:
 decl %ecx
 jnz .subtract_loop
.check_quotient:
 movl -20(%ebp), %ecx
 xorl %ebx, %ebx
.compare_loop:
 movl 4(%edi, %ebx, 4), %eax
 cmpl %eax, (%esp, %ebx, 4)
 ja .store_quotient
 jb .correct_quotient
 incl %ebx
 decl %ecx
 jnz .compare_loop
.correct_quotient:
 incl -16(%ebp)
 movl -20(%ebp), %ecx
 clc
.correct_loop:
 movl -4(%esp, %ecx, 4), %eax
 sbbl %eax, (%edi, %ecx, 4)
 decl %ecx
 jnz .correct_loop
.store_quotient:
 movl -16(%ebp), %edx
 movl 16(%ebp), %ecx
 btl $0, -24(%ebp)
 movl -24(%ebp), %ebx
 jnc .msb
 shrl $1, %ebx
 movl %edx, (%ecx, %ebx, 8)
 jmp .set_counter
.msb:
 shrl $1, %ebx
 movl %edx, 4(%ecx, %ebx, 8)
.set_counter:
 decl -20(%ebp)
 incl -24(%ebp)
 addl $4, %edi
 jmp .ozawa
.end:
 movl 16(%ebp), %edx
 cmpl $0, -28(%ebp)
 je .exponent
 movl 20(%ebp), %ecx
 shll $1, -16(%ebp)
.shift_loop:
 rcll $1, (%edx, %ecx, 8)
 rcll $1, 4(%edx, %ecx, 8)
 decl %ecx
 jnz .shift_loop
 jmp .exponent
.q2:
 movl $0, -16(%ebp)
 cmpl $2, -20(%ebp)
 je .end
 jmp .check_quotient
.store_A:
 movl 20(%ebp), %ecx
 movl 16(%ebp), %edi
 movl $0, -16(%ebp)
 movl $0, -28(%ebp)
 leal 8(%eax), %esi
 shll $1, %ecx
 addl $8, %edi
 cld
 rep movsl
 jmp .exponent
        .ident "$Id: $"
