.text
        .p2align 4
 .globl exflib_float_round_chop_f90_
 .type exflib_float_round_chop_f90_, @function
exflib_float_round_chop_f90_:
 .globl exflib_float_round_chop_f77_
 .type exflib_float_round_chop_f77_, @function
exflib_float_round_chop_f77_:
 ret
 .globl exflib_float_round_chop
 .type exflib_float_round_chop, @function
exflib_float_round_chop:
 ret
        .p2align 4
 .globl exflib_float_round_plus_f90_
 .type exflib_float_round_plus_f90_, @function
exflib_float_round_plus_f90_:
 movl 4(%esp), %eax
 movl (%eax), %eax
 movl %eax, 4(%esp)
 .globl exflib_float_round_plus_f77_
 .type exflib_float_round_plus_f77_, @function
exflib_float_round_plus_f77_:
 movl 12(%esp), %eax
 movl 8(%esp), %edx
 movl (%eax), %eax
 movl (%edx), %edx
 movl %eax, 12(%esp)
 movl %edx, 8(%esp)
 .globl exflib_float_round_plus
 .type exflib_float_round_plus, @function
exflib_float_round_plus:
 pushl %ebp
 pushl %ebx
 movl 16(%esp), %eax
 movl 20(%esp), %ecx
 movl 12(%esp), %ebp
 movl $1, %ebx
 cmpl $0, %eax
 je .exflib_float_round_end
 incl %eax
 movl $2, %eax
 cmovz %eax, %ebx
 movl 4(%ebp), %eax
 btl $31, %eax
 jc .exflib_float_round_end
.exflib_float_round_up:
 shll $1, %eax
 cmpl $0, %eax
 je .exflib_float_round_zero
.exflib_float_round_up_loop:
 movl (%ebp, %ecx, 8), %eax
 movl 4(%ebp, %ecx, 8), %edx
 addl %ebx, %eax
 adcl $0, %edx
 movl %eax, (%ebp, %ecx, 8)
 movl %edx, 4(%ebp, %ecx, 8)
 jnc .exflib_float_round_end
 movl $1, %ebx
 decl %ecx
 jnz .exflib_float_round_up_loop
.exflib_float_round_exp:
 movl (%ebp), %eax
 movl 4(%ebp), %edx
 addl $1, %eax
 movl %edx, %ecx
 adcl $0, %edx
 xorl %edx, %ecx
 btl $31, %ecx
 jc .exflib_float_round_overflow
 movl %eax, (%ebp)
 movl %edx, 4(%ebp)
.exflib_float_round_end:
 popl %ebx
 popl %ebp
 ret
.exflib_float_round_overflow:
 xorl %eax, %eax
 notl %eax
 movl %eax, (%ebp)
 shrl $1, %eax
 orl %eax, 4(%ebp)
 popl %ebx
 popl %ebp
 ret
        .p2align 4
 .globl exflib_float_round_minus_f90_
 .type exflib_float_round_minus_f90_, @function
exflib_float_round_minus_f90_:
 movl 4(%esp), %eax
 movl (%eax), %eax
 movl %eax, 4(%esp)
 .globl exflib_float_round_minus_f77_
 .type exflib_float_round_minus_f77_, @function
exflib_float_round_minus_f77_:
 movl 12(%esp), %eax
 movl 8(%esp), %edx
 movl (%eax), %eax
 movl (%edx), %edx
 movl %eax, 12(%esp)
 movl %edx, 8(%esp)
 .globl exflib_float_round_minus
 .type exflib_float_round_minus, @function
exflib_float_round_minus:
 pushl %ebp
 pushl %ebx
 movl 16(%esp), %eax
 movl 20(%esp), %ecx
 movl 12(%esp), %ebp
 movl $1, %ebx
 cmpl $0, %eax
 je .exflib_float_round_end
 incl %eax
 movl $2, %eax
 cmovz %eax, %ebx
 movl 4(%ebp), %eax
 btl $31, %eax
 jc .exflib_float_round_up
 popl %ebx
 popl %ebp
 ret
        .p2align 4
 .globl exflib_float_round_near_f90_
 .type exflib_float_round_near_f90_, @function
exflib_float_round_near_f90_:
 movl 4(%esp), %eax
 movl (%eax), %eax
 movl %eax, 4(%esp)
 .globl exflib_float_round_near_f77_
 .type exflib_float_round_near_f77_, @function
exflib_float_round_near_f77_:
 movl 12(%esp), %eax
 movl 8(%esp), %edx
 movl (%eax), %eax
 movl (%edx), %edx
 movl %eax, 12(%esp)
 movl %edx, 8(%esp)
 .globl exflib_float_round_near
 .type exflib_float_round_near, @function
exflib_float_round_near:
 pushl %ebp
 pushl %ebx
 movl 16(%esp), %edx
 movl 12(%esp), %ebp
 movl 4(%ebp), %eax
 movl $1, %ebx
 xorl %ecx, %ecx
 stc
 rcrl $1, %ecx
 cmpl %ecx, %edx
 movl 20(%esp), %ecx
 je .exflib_float_round_tiebreak
 ja .exflib_float_round_up
 popl %ebx
 popl %ebp
 ret
.exflib_float_round_tiebreak:
 btl $0, (%ebp, %ecx, 8)
 jc .exflib_float_round_up
 popl %ebx
 popl %ebp
 ret
.exflib_float_round_zero:
 movl (%ebp), %eax
 cmpl $0, %eax
 jne .exflib_float_round_up_loop
 pushl %edi
 movl %ebp, %edi
 movl $1, (%edi)
 addl $8, %edi
 shll $1, %ecx
 rep stosl
 popl %edi
 popl %ebx
 popl %ebp
 ret
        .ident "$Id: $"
