.ident "$Id: Time-stamp: \"2006-03-07 09:43:28 fujiwara\", array_mul_h.S $"
.text
 .p2align 4
.globl exflib_array_mul_h_f77_
 .type exflib_array_mul_h_f77_, @function
exflib_array_mul_h_f77_:
 movq (%rcx), %rcx
.globl exflib_array_mul_h
 .type exflib_array_mul_h, @function
exflib_array_mul_h:
 movq %rdi, %rax
 movq %rsi, %rdi
 movq %rdx, %rsi
 movq %rax, %rdx
 pushq %rbx
 pushq %rbp
 pushq %r12
 movq %rcx, %r12
 pushq %r13
 addq $2, %r12
 pushq %r14
 shlq $3, %r12
 pushq %rdx
 movq %rsp, %r11
 subq %r12, %rsp
 movq %rdi, %r12
 movq %rsi, %r13
 movq %rcx, %r14
 movq %r14, %rcx
 movq %r13, %rsi
 leaq 16(%rdi), %rdi
 leaq -8(%rsi,%rcx,8), %rsi
 xorq %rbx, %rbx
 xorq %r10, %r10
 subq $2, %rcx
.compute_only_msb:
 movq (%rdi), %rax
 movq (%rsi), %rdx
 mulq %rdx
 leaq 8(%rdi), %rdi
 leaq -8(%rsi), %rsi
 addq %rdx, %rbx
 adcq $0, %r10
 decq %rcx
 jnz .compute_only_msb
 movq %r14, %r8
.mul_outer_loop:
 movq %r8, %rcx
 cmpq %r8, %r14
 je .init
 movq %r12, %rdi
 leaq (%r13, %rcx, 8), %rsi
 incq %rcx
.cont:
 movq %rbx, %rbp
 movq %r10, %rbx
 xorq %r10, %r10
.mul_inner_loop:
 movq (%rdi), %rax
 movq (%rsi), %rdx
 mulq %rdx
 leaq 8(%rdi), %rdi
 leaq -8(%rsi), %rsi
 addq %rax, %rbp
 adcq %rdx, %rbx
 adcq $0, %r10
 decq %rcx
 jnz .mul_inner_loop
 movq %rbp, 8(%rsp,%r8,8)
 decq %r8
 jns .mul_outer_loop
 jmp .exit_mpy_half
.init:
        leaq 8(%r12), %rdi
        leaq -8(%r13, %r14, 8), %rsi
        decq %rcx
        jmp .cont
.exit_mpy_half:
 movq 8(%rsp, %r14, 8), %rdx
 movq (%r11), %rdi
 xorq %rax, %rax
 leaq 8(%rsp), %rsi
 movq %r14, %rcx
 stc
 rcrq $1, %rax
 cmpq %rdx, %rax
 jbe .exflib_array_mul_h_roundcheck
 cld
 rep movsq
.exflib_array_mul_h_exit:
 leaq 8(%r11), %rsp
 movq %rbx, %rax
 popq %r14
 popq %r13
 popq %r12
 popq %rbp
 popq %rbx
 ret
.exflib_array_mul_h_roundcheck:
 leaq -8(%rsi, %rcx, 8), %rsi
 leaq -8(%rdi, %rcx, 8), %rdi
 stc
.exflib_array_mul_h_roundup:
 movq (%rsi), %rax
 leaq -8(%rsi), %rsi
 adcq $0, %rax
 movq %rax, (%rdi)
 leaq -8(%rdi), %rdi
 decq %rcx
 jc .exflib_array_mul_h_roundup
        jz .exflib_array_mul_h_exit
 std
 rep movsq
 cld
 jmp .exflib_array_mul_h_exit
