.ident "$Id: Time-stamp: \"2006-03-07 09:44:31 fujiwara\", float_add.S $"
.text
 .p2align 4
.globl exflib_float_add_f90_
 .type exflib_float_add_f90_, @function
exflib_float_add_f90_:
 movq (%rdi), %rdi
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_add_f77_
 .type exflib_float_add_f77_, @function
exflib_float_add_f77_:
 movq (%rcx), %rcx
.globl exflib_float_add
 .type exflib_float_add, @function
exflib_float_add:
 movq (%rsi), %r8
 movq (%rdx), %r9
 movq (%rdx), %r10
 xorq %r11, %r11
 pushq %rbp
 pushq %rbx
 movq %rdx, %rbx
 movq %rdi, %rdx
 movq %rcx, %rbp
 xorq %r8, %r10
 js .sub
.add:
 shlq $1, %r8
 jz .A_is_zero
 shlq $1, %r9
 jz .B_is_zero
 cmpq %r9, %r8
 jne .add1
 xorq %r10, %r10
.add_compare_m:
 movq 8(%rsi, %r10, 8), %rax
 movq 8(%rbx, %r10, 8), %rdx
 incq %r10
 cmpq %rdx, %rax
 jne .add1
 decq %rcx
 jnz .add_compare_m
 movq (%rsi), %rax
 movq (%rsi), %rdx
 addq $8, %rsi
 addq $8, %rdi
 addq $1, %rax
 xorq %rax, %rdx
 js .overflow2
 movq %rbp, %rcx
 movq %rax, -8(%rdi)
 cld
 rep movsq
 xorq %rax, %rax
 popq %rbx
 popq %rbp
 ret
.overflow2:
 leaq -8(%rsi), %rsi
 leaq -8(%rdi), %rdi
 jmp .overflow
 .p2align 4
.globl exflib_float_sub_f90_
 .type exflib_float_sub_f90_, @function
exflib_float_sub_f90_:
 movq (%rdi), %rdi
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_sub_f77_
 .type exflib_float_sub_f77_, @function
exflib_float_sub_f77_:
 movq (%rcx), %rcx
.globl exflib_float_sub
 .type exflib_float_sub, @function
exflib_float_sub:
 movq (%rsi), %r8
 movq (%rdx), %r9
 movq (%rdx), %r10
 movq $1, %r11
 pushq %rbp
 pushq %rbx
 movq %rdx, %rbx
 movq %rdi, %rdx
 movq %rcx, %rbp
 xorq %r8, %r10
 js .add
.sub:
 shlq $1, %r8
 jz .A_is_zero
 shlq $1, %r9
 jz .B_is_zero
 cmpq %r9, %r8
 jne .sub1
 xorq %r10, %r10
.sub_compare_m:
 movq 8(%rsi, %r10, 8), %rax
 movq 8(%rbx, %r10, 8), %rdx
 incq %r10
 cmpq %rdx, %rax
 jne .sub1
 decq %rcx
 jnz .sub_compare_m
 xorq %rax, %rax
 movq %rax, (%rdi)
 popq %rbx
 popq %rbp
 ret
 .p2align 4
.add1:
 movq $0, %rax
 movq $1, %rdx
 cmovb %rsi, %r10
 cmovb %rbx, %rsi
 cmovb %r10, %rbx
 cmovb %rdx, %rax
 cmovb %r8, %r10
 cmovb %r9, %r8
 cmovb %r10, %r9
 andq %rax, %r11
 shlq $63, %r11
 subq %r9, %r8
 movq %rbp, %rcx
 jz .add_no_shift
 shrq $1, %r8
 shlq $6, %rcx
 cmpq %rcx, %r8
 ja .add_loss_trailing
 movq %r8, %r9
 movq %r8, %r10
 andq $63, %r9
 jz .add_no_local_shift
 xorq %rdx, %rdx
 shrq $6, %r10
 jz .add_hint
 movq %r10, %r8
 movq %rbp, %rcx
.add_sticky:
 orq (%rbx, %rcx, 8), %rdx
 decq %rcx
 decq %r8
 jnz .add_sticky
 incq %r8
 cmpq $0, %rdx
 cmovne %r8, %rdx
.add_hint:
 movq $1, %r8
 movq $64, %rcx
 movq %rbp, %rax
 subq %r9, %rcx
 subq %r10, %rax
 movq (%rbx, %rax, 8), %rax
 shlq %cl, %rax
 orq %rdx, %rax
 pushq %rax
 movd %r9, %mm1
 movd %rcx, %mm0
 movd %r8, %mm4
 movq %rbp, %rcx
 subq %r10, %rcx
 decq %rcx
 jz .add_add2
 movq %rbp, %r8
.add_add1:
 movq 8(%rbx, %rcx, 8), %mm2
 movq (%rbx, %rcx, 8), %mm3
 movq (%rsi, %r8, 8), %rax
 decq %r8
 psrlq %mm1, %mm2
 psllq %mm0, %mm3
 por %mm2, %mm3
 movd %mm3, %rdx
 adcq %rdx, %rax
 movq %rax, 8(%rdi, %r8, 8)
 decq %rcx
 jnz .add_add1
.add_add2:
 movq 8(%rbx), %mm3
 psllq %mm0, %mm4
 movq 8(%rsi, %r10, 8), %rax
 psrlq %mm1, %mm3
 por %mm4, %mm3
 movd %mm3, %rdx
 adcq %rdx, %rax
 movq %rax, 8(%rdi, %r10, 8)
 emms
 incq %r10
 decq %r10
 jz .add_check_shift
.add_add3:
 movq (%rsi, %r10, 8), %rax
 adcq $0, %rax
 movq %rax, (%rdi, %r10, 8)
 decq %r10
 jnz .add_add3
.add_check_shift:
 popq %rax
 jnc .add_check_ret
 movq %rdi, %rdx
 incq %r10
 clc
.add_shift:
 rcrq $1, 8(%rdx)
 leaq 8(%rdx), %rdx
 decq %rbp
 jnz .add_shift
 rcrq $1, %rax
 cmovc %r10, %rbp
 orq %rbp, %rax
.add_check_ret:
 movq $1, %r9
 notq %rcx
 xorq %r8, %r8
 cmpq %rcx, %rax
 cmove %r9, %r8
 subq %r8, %rax
.add_exp:
 movq (%rsi), %rdx
 movq (%rsi), %r8
 addq %r10, %rdx
 xorq %rdx, %r8
 js .overflow
 addq %r11, %rdx
 movq %rdx, (%rdi)
 popq %rbx
 popq %rbp
 ret
.add_no_shift:
 movq (%rsi, %rbp, 8), %rax
 movq (%rbx, %rbp, 8), %rdx
 adcq %rdx, %rax
 movq %rax, (%rdi, %rbp, 8)
 decq %rbp
 jnz .add_no_shift
 movq %rdi, %rdx
 movq (%rsi), %r10
.add_ns_shift_right:
 rcrq $1, 8(%rdx)
 leaq 8(%rdx), %rdx
 decq %rcx
 jnz .add_ns_shift_right
 rcrq $1, %rcx
 movq %r10, %r8
 incq %r10
 movq %rcx, %rax
 xorq %r10, %r8
 js .overflow
 addq %r11, %r10
 movq %r10, (%rdi)
 popq %rbx
 popq %rbp
 ret
.add_no_local_shift:
 shrq $6, %r10
 movq %r10, %r8
 xorq %rdx, %rdx
 movq %rbp, %rcx
 decq %r8
 jz .add_nls_hint
.add_nls_sticky:
 orq (%rbx, %rcx, 8), %rdx
 decq %rcx
 decq %r8
 jnz .add_nls_sticky
.add_nls_hint:
 incq %r8
 movq %rbp, %rcx
 subq %r10, %rcx
 movq 8(%rbx, %rcx, 8), %rax
 cmpq $0, %rdx
 cmovne %r8, %rdx
 orq %rdx, %rax
 pushq %rax
 cmpq $0, %rcx
 je .add_nls_hidden_one
 leaq (%rsi, %r10, 8), %r9
 leaq (%rdi, %r10, 8), %rdx
 clc
.add_nls_add:
 movq (%r9, %rcx, 8), %rax
 adcq (%rbx, %rcx, 8), %rax
 movq %rax, (%rdx, %rcx, 8)
 decq %rcx
 jnz .add_nls_add
.add_nls_hidden_one:
 adcq (%rsi, %r10, 8), %r8
 movq %r8, (%rdi, %r10, 8)
 decq %r10
 jz .add_check_shift
.add_nls_add2:
 movq (%rsi, %r10, 8), %rax
 adcq $0, %rax
 movq %rax, (%rdi, %r10, 8)
 decq %r10
 jnz .add_nls_add2
 jmp .add_check_shift
.add_loss_trailing:
 movq (%rsi), %rdx
 movq %rbp, %rcx
 addq $8, %rsi
 addq $8, %rdi
 addq %r11, %rdx
 movq %rdx, -8(%rdi)
 cld
 rep movsq
 movq %rbp, %rcx
 shlq $6, %rbp
 incq %rbp
 cmpq %rbp, %r8
 je .add_lt_hint
 xorq %rax, %rax
 incq %rax
 popq %rbx
 popq %rbp
 ret
.add_lt_hint:
 xorq %rdx, %rdx
 xorq %rax, %rax
 btsq $63, %rdx
.add_lt_check_B:
 orq (%rbx, %rcx, 8), %rax
 decq %rcx
 jnz .add_lt_check_B
 incq %rcx
 cmpq $0, %rax
 cmovne %rcx, %rax
 orq %rdx, %rax
 popq %rbx
 popq %rbp
 ret
 .p2align 4
.sub1:
 movq $0, %rax
 movq $1, %rdx
 cmovb %rsi, %r10
 cmovb %rbx, %rsi
 cmovb %r10, %rbx
 cmovb %rdx, %rax
 cmovb %r8, %r10
 cmovb %r9, %r8
 cmovb %r10, %r9
 andq %rax, %r11
 shlq $63, %r11
 pushq %r11
 movq %rbp, %rcx
 subq %r9, %r8
 jz .sub_no_shift
 shrq $1, %r8
 shlq $6, %rcx
 cmpq %rcx, %r8
 ja .sub_loss_trailing
 movq %r8, %r9
 movq %r8, %r10
 andq $63, %r9
 jz .sub_no_local_shift
 xorq %rax, %rax
 xorq %rdx, %rdx
 shrq $6, %r10
 jz .sub_hint
 movq %rbp, %rax
 subq %r10, %rax
 movq 8(%rbx, %rax, 8), %rdx
 movq 8(%rbx, %rax, 8), %rax
 movq %r10, %r11
 movq $64, %rcx
 subq %r9, %rcx
 shlq %cl, %rdx
 subq $2, %r11
 jle .sub_sticky1
 movq %rbp, %rcx
.sub_sticky:
 orq (%rbx, %rcx, 8), %rdx
 decq %rcx
 decq %r11
 jnz .sub_sticky
.sub_sticky1:
 incq %r11
 cmpq $0, %rdx
 cmovne %r11, %rdx
 movq %r9, %rcx
 shrq %cl, %rax
.sub_hint:
 movq $1, %r11
 movq %rbp, %r8
 subq %r10, %r8
 movq (%rbx, %r8, 8), %r8
 movq $64, %rcx
 subq %r9, %rcx
 shlq %cl, %r8
 orq %rax, %r8
 orq %rdx, %r8
 xorq %rax, %rax
 movd %r9, %mm1
 movd %rcx, %mm0
 movd %r11, %mm4
 movq %rbp, %rcx
 subq %r10, %rcx
 subq %r8, %rax
 pushq %rax
 decq %rcx
 jz .sub_sub2
 movq %rbp, %r11
.sub_sub1:
 movq 8(%rbx, %rcx, 8), %mm2
 movq (%rbx, %rcx, 8), %mm3
 movq (%rsi, %r11, 8), %rax
 decq %r11
 psrlq %mm1, %mm2
 psllq %mm0, %mm3
 por %mm2, %mm3
 movd %mm3, %rdx
 sbbq %rdx, %rax
 movq %rax, 8(%rdi, %r11, 8)
 decq %rcx
 jnz .sub_sub1
.sub_sub2:
 movq 8(%rbx), %mm3
 psllq %mm0, %mm4
 movq 8(%rsi, %r10, 8), %rax
 psrlq %mm1, %mm3
 por %mm4, %mm3
 movd %mm3, %rdx
 sbbq %rdx, %rax
 movq %rax, 8(%rdi, %r10, 8)
 emms
 incq %r10
 decq %r10
 jz .sub_sub_end
.sub_sub3:
 movq (%rsi, %r10, 8), %rax
 sbbq $0, %rax
 movq %rax, (%rdi, %r10, 8)
 decq %r10
 jnz .sub_sub3
.sub_sub_end:
 movq %rax, %rdx
 popq %rax
 jnc .sub_check_ret
.sub_check_cancellation:
 cmpq $0, %rdx
 je .sub_cancellation
 jg .sub_shift_left
.sub_shift_left_1bit:
 incq %rcx
 shlq $1, %rax
.sub_shift_left_1bit_loop:
 rclq $1, (%rdi, %rbp, 8)
 decq %rbp
 jnz .sub_shift_left_1bit_loop
.sub_check_ret:
 movq $1, %r11
 notq %r10
 xorq %r8, %r8
 cmpq %r10, %rax
 cmove %r11, %r8
 subq %r8, %rax
.sub_exp:
 popq %r11
 movq (%rsi), %rdx
 movq (%rsi), %r8
 subq %rcx, %rdx
 xorq %rdx, %r8
 js .underflow
 addq %r11, %rdx
 movq %rdx, (%rdi)
 popq %rbx
 popq %rbp
 ret
.sub_shift_left:
 bsrq %rdx, %r11
 movq $64, %rcx
 movd %rax, %mm2
 subq %r11, %rcx
 movd %r11, %mm1
 movd %rcx, %mm0
 shlq %cl, %rax
.sub_shift_left_loop:
 movq (%rdi, %rbp, 8), %mm3
 psrlq %mm1, %mm2
 psllq %mm0, %mm3
 por %mm2, %mm3
 movq (%rdi, %rbp, 8), %mm2
 movq %mm3, (%rdi, %rbp, 8)
 decq %rbp
 jnz .sub_shift_left_loop
 emms
 cmpq %rbp, %r11
 cmove %rbp, %rax
 jmp .sub_check_ret
.sub_cancellation:
 movq %rbp, %r11
 xorq %r8, %r8
 decq %r11
.sub_finding_first_nonzero:
 movq 16(%rdi, %r8, 8), %rdx
 incq %r8
 cmpq $0, %rdx
 jne .sub_cancel_prologue
 decq %r11
 jnz .sub_finding_first_nonzero
 movq %rbp, %rcx
 shlq $1, %rax
 shlq $6, %rcx
 movq %rax, 8(%rdi)
 incq %rcx
 xorq %rax, %rax
 jmp .sub_exp
.sub_cancel_prologue:
 bsrq %rdx, %r11
 movd %rax, %mm4
 movq $64, %rcx
 subq %r11, %rcx
 movd %r11, %mm1
 movd %rcx, %mm0
 shlq %cl, %rax
 movq %r8, %rdx
 shlq $6, %rdx
 addq %rdx, %rcx
 subq %r8, %rbp
 movq %rdi, %rdx
 decq %rbp
 jz .sub_cancel_shift_hint
.sub_cancel_shift:
 movq 8(%rdx, %r8, 8), %mm2
 movq 16(%rdx, %r8, 8), %mm3
 leaq 8(%rdx), %rdx
 psllq %mm0, %mm2
 psrlq %mm1, %mm3
 por %mm3, %mm2
 movq %mm2, (%rdx)
 decq %rbp
 jnz .sub_cancel_shift
.sub_cancel_shift_hint:
 movq 8(%rdx, %r8, 8), %mm2
 psllq %mm1, %mm4
 psllq %mm0, %mm2
 por %mm4, %mm2
 movq %mm2, 8(%rdx)
 emms
 cmpq %rbp, %r11
 cmove %rbp, %rax
.sub_cancel_zero_padding:
 movq $0, 8(%rdx, %r8, 8)
 decq %r8
 jnz .sub_cancel_zero_padding
 jmp .sub_check_ret
.sub_no_shift:
 movq (%rsi, %rcx, 8), %rdx
 movq (%rbx, %rcx, 8), %rax
 sbbq %rax, %rdx
 movq %rdx, (%rdi, %rcx, 8)
 decq %rcx
 jnz .sub_no_shift
 xorq %r10, %r10
 xorq %rax, %rax
 jmp .sub_check_cancellation
.sub_no_local_shift:
 shrq $6, %r10
 movq %r10, %r11
 xorq %rdx, %rdx
 movq %rbp, %rcx
 decq %r11
 jz .sub_nls_hint
.sub_nls_sticky:
 orq (%rbx, %rcx, 8), %rdx
 decq %rcx
 decq %r11
 jnz .sub_nls_sticky
.sub_nls_hint:
 incq %r11
 movq %rbp, %rcx
 subq %r10, %rcx
 movq 8(%rbx, %rcx, 8), %r8
 xorq %rax, %rax
 cmpq $0, %rdx
 cmovne %r11, %rdx
 orq %rdx, %r8
 subq %r8, %rax
 incq %rcx
 pushq %rax
 decq %rcx
 jz .sub_nls_hidden_one
 leaq (%rsi, %r10, 8), %r9
 leaq (%rdi, %r10, 8), %rdx
.sub_nls_sub:
 movq (%r9, %rcx, 8), %rax
 sbbq (%rbx, %rcx, 8), %rax
 movq %rax, (%rdx, %rcx, 8)
 decq %rcx
 jnz .sub_nls_sub
.sub_nls_hidden_one:
 movq (%rsi, %r10, 8), %rax
 sbbq %r11, %rax
 movq %rax, (%rdi, %r10, 8)
 decq %r10
 jz .sub_nls_check_shift
.sub_nls_sub2:
 movq (%rsi, %r10, 8), %rax
 sbbq $0, %rax
 movq %rax, (%rdi, %r10, 8)
 decq %r10
 jnz .sub_nls_sub2
.sub_nls_check_shift:
 movq %rax, %rdx
 popq %rax
 jnc .sub_check_ret
 jmp .sub_shift_left_1bit
.sub_loss_trailing:
 addq $2, %rcx
 popq %r11
 cmpq %rcx, %r8
 jb .sub_lt_sticky1
 ja .sub_lt_sticky3
 xorq %rdx, %rdx
 movq %rbp, %rcx
.sub_lt_sticky2:
 orq (%rbx, %rcx, 8), %rdx
 decq %rcx
 jnz .sub_lt_sticky2
 incq %rcx
 xorq %r8, %r8
 btsq $62, %r8
 cmpq $0, %rdx
 cmovne %rcx, %rdx
 orq %rdx, %r8
.sub_lt_hint:
 xorq %rax, %rax
 movq %rbp, %rcx
 subq %r8, %rax
.sub_lt_sbb:
 movq (%rsi, %rcx, 8), %rdx
 sbbq $0, %rdx
 movq %rdx, (%rdi, %rcx, 8)
 decq %rcx
 jnz .sub_lt_sbb
 movq (%rsi), %rdx
 jnc .sub_lt_exp
 incq %rcx
 shlq $1, %rax
.sub_lt_shift_left:
 rclq $1, (%rdi, %rbp, 8)
 decq %rbp
 jnz .sub_lt_shift_left
.sub_lt_exp:
 subq %rcx, %rdx
 addq %r11, %rdx
 movq %rdx, (%rdi)
 popq %rbx
 popq %rbp
 ret
.sub_lt_sticky3:
 movq $2, %r8
 jmp .sub_lt_hint
.sub_lt_sticky1:
 xorq %r8, %r8
 movq 8(%rbx), %rdx
 movq %rbp, %rcx
 shlq $1, %rdx
 rcrq $1, %r8
 decq %rcx
.sub_lt_sticky1_loop:
 orq 8(%rbx, %rcx, 8), %rdx
 decq %rcx
 jnz .sub_lt_sticky1_loop
 incq %rcx
 stc
 rcrq $1, %r8
 cmpq $0, %rdx
 cmovne %rcx, %rdx
 orq %rdx, %r8
 jmp .sub_lt_hint
.A_is_zero:
 movq %rbx, %rsi
 andq $1, %r11
 jmp .return_zero
.B_is_zero:
 andq $0, %r11
.return_zero:
 shlq $63, %r11
 movq (%rsi), %r8
 incq %rcx
 cld
 rep movsq
 addq %r11, %r8
 movq %r8, (%rdx)
 xorq %rax, %rax
 popq %rbx
 popq %rbp
 ret
.overflow:
 xorq %rcx, %rdx
 notq %rcx
 movq (%rsi), %rdx
 shrq $1, %rcx
 orq %rcx, %rdx
 xorq %rax, %rax
 addq %r11, %rdx
 movq %rdx, (%rdi)
 popq %rbx
 popq %rbp
 ret
.underflow:
 movq (%rsi), %rdx
 xorq %r8, %r8
 xorq %rax, %rax
 btsq $63, %r8
 andq %r8, %rdx
 incq %rax
 addq %r11, %rdx
 movq %rdx, (%rdi)
 popq %rbx
 popq %rbp
 ret
