 .ident "$Id: Time-stamp: \"2006-03-07 09:45:17 fujiwara\", float_imul.S $"
.text
 .p2align 4
.globl exflib_float_imul_f90_
 .type exflib_float_imul_f90_, @function
exflib_float_imul_f90_:
 movq (%rdi), %rdi
 movq (%rsi), %rsi
.globl exflib_float_imul_f77_
 .type exflib_float_imul_f77_, @function
exflib_float_imul_f77_:
 movq (%rdx), %rdx
 movq (%rcx), %rcx
.globl exflib_float_imul
 .type exflib_float_imul, @function
exflib_float_imul:
 movq %rdi, %rax
 movq %rsi, %rdi
 movq %rdx, %rsi
 movq %rax, %rdx
 movq (%rdi), %r9
 movq (%rdi), %rax
 movq (%rdi), %r11
 cmpq $0, %rsi
 je .zero
 xorq %rsi, %r9
 shlq $1, %rax
 shrq $63, %r9
 cmpq $0, %rax
 je .zero
 movq %rdx, %r8
 shlq $63, %r9
 shlq $1, %r11
 xorq %r10, %r10
 pushq %rcx
 shrq $1, %r11
 btq $63, %rsi
 jnc .exflib_float_imul_loop
 negq %rsi
.exflib_float_imul_loop:
 movq (%rdi, %rcx, 8), %rax
 mulq %rsi
 addq %r10, %rax
 adcq $0, %rdx
 movq %rax, (%r8, %rcx, 8)
 movq %rdx, %r10
 decq %rcx
 jnz .exflib_float_imul_loop
 adcq %rsi, %r10
 popq %rdx
 xorq %rax, %rax
 movq %r10, (%r8)
 cmpq $1, %r10
 cmove %rax, %r10
 je .exponent
 bsrq %r10, %rcx
 movq $64, %r10
 subq %rcx, %r10
 movq (%r8, %rdx, 8), %rax
 xchgq %rcx, %r10
 shlq %cl, %rax
 movd %rcx, %mm1
 movd %r10, %mm0
.shift:
 movq (%r8, %rdx, 8), %mm2
 movq -8(%r8, %rdx, 8), %mm3
 psrlq %mm0, %mm2
 psllq %mm1, %mm3
 por %mm3, %mm2
 decq %rdx
 movq %mm2, 8(%r8, %rdx, 8)
 jnz .shift
 emms
.exponent:
 addq %r10, %r11
 btq $63, %r11
 jc .overflow
 orq %r9, %r11
 movq %r11, (%r8)
 ret
.overflow:
 xorq %rax, %rax
 xorq %rdx, %rdx
 notq %rdx
 shrq $1, %rdx
 orq %rdx, %r9
 movq %r9, (%r8)
 ret
.zero:
 xorq %r11, %rsi
 shrq $63, %rsi
 xorq %rax, %rax
 shlq $63, %rsi
 movq %rsi, (%rdx)
 ret
