.ident "$Id: Time-stamp: \"2006-03-07 09:46:16 fujiwara\", float_mul_h.S $"
.text
 .p2align 4
.globl exflib_float_mul_h_f90_
 .type exflib_float_mul_h_f90_, @function
exflib_float_mul_h_f90_:
 movq (%rdi), %rdi
 movq (%rsi), %rsi
 movq (%rdx), %rdx
.globl exflib_float_mul_h_f77_
 .type exflib_float_mul_h_f77_, @function
exflib_float_mul_h_f77_:
 movq (%rcx), %rcx
.globl exflib_float_mul_h
 .type exflib_float_mul_h, @function
exflib_float_mul_h:
 movq %rdi, %rax
 movq %rsi, %rdi
 movq %rdx, %rsi
 movq %rax, %rdx
 movq (%rdi), %rax
 movq (%rsi), %r8
 shlq $1, %rax
 shlq $1, %r8
 cmpq $0, %rax
 je .zero
 cmpq $0, %r8
 je .zero
 pushq %rbx
 pushq %rbp
 pushq %r12
 movq %rcx, %r12
 pushq %r13
 addq $2, %r12
 pushq %r14
 shlq $3, %r12
 pushq %rdx
 movq %rsp, %r11
 subq %r12, %rsp
 movq %rdi, %r12
 movq %rsi, %r13
 movq %rcx, %r14
 leaq 8(%r12), %r12
 leaq 8(%r13), %r13
 movq %r14, %rcx
 leaq 8(%r12), %rdi
 leaq -8(%r13,%rcx,8), %rsi
 xorq %rbx, %rbx
 xorq %r10, %r10
 decq %rcx
 decq %r14
.compute_only_msb:
 movq (%rdi), %rax
 movq (%rsi), %rdx
 mulq %rdx
 leaq 8(%rdi), %rdi
 leaq -8(%rsi), %rsi
 addq %rdx, %rbx
 adcq $0, %r10
 decq %rcx
 jnz .compute_only_msb
 movq %r14, %r8
.mul_outer_loop:
 movq %r8, %rcx
 movq %r12, %rdi
 leaq (%r13, %rcx, 8), %rsi
 incq %rcx
 movq %rbx, %rbp
 movq %r10, %rbx
 xorq %r10, %r10
.mul_inner_loop:
 movq (%rdi), %rax
 movq (%rsi), %rdx
 mulq %rdx
 leaq 8(%rdi), %rdi
 leaq -8(%rsi), %rsi
 addq %rax, %rbp
 adcq %rdx, %rbx
 adcq $0, %r10
 decq %rcx
 jnz .mul_inner_loop
 movq %rbp, 8(%rsp,%r8,8)
 decq %r8
 jns .mul_outer_loop
 movq %rbx, (%rsp)
 incq %r14
 movq %r12, %rsi
 movq %r13, %rbx
 movq %r14, %rcx
 xorq %r9, %r9
.add_mantissa:
 movq -8(%rsp, %rcx, 8), %r8
 movq -8(%rsi, %rcx, 8), %rax
 movq -8(%rbx, %rcx, 8), %rdx
 movq %r9, %r10
 xorq %r9, %r9
 addq %r8, %r10
 adcq $0, %r9
 addq %rax, %r10
 adcq $0, %r9
 addq %rdx, %r10
 adcq $0, %r9
 movq %r10, -8(%rsp, %rcx, 8)
 decq %rcx
 jnz .add_mantissa
 incq %r9
 movq %rsp, %rsi
 movq (%r11), %rdi
 xorq %rcx, %rcx
 btq $1, %r9
 adcq $0, %rcx
 rcrq %cl, %r9
 movq %rdi, %r9
 movq %r14, %rdx
.store:
 movq (%rsi), %rax
 leaq 8(%rsi), %rsi
 leaq 8(%r9), %r9
 rcrq %cl, %rax
 movq %rax, (%r9)
 decq %rdx
 jnz .store
 movq (%rsi), %rax
 movq $0, %rbx
 movq %r14, %rdx
 rclq $1, %rbx
 shlq $1, %rdx
 addq %rdx, %rax
 adcq $0, %rbx
 rcrq %cl, %rbx
 rcrq %cl, %rax
 movq $0, %rdx
 rclq $1, %rdx
 orq %rdx, %rax
 cmpq $0, %rbx
 jne .overestimate
.sign:
 movq -8(%r12), %r8
 movq -8(%r13), %r9
 movq -8(%r12), %r10
 xorq %r9, %r8
 shrq $63, %r8
 shlq $63, %r8
 shlq $1, %r9
 shlq $1, %r10
 shrq $1, %r9
 shrq $1, %r10
 addq %rcx, %r9
 xorq %rcx, %rcx
 addq %r10, %r9
 notq %rcx
 shrq $2, %rcx
 cmpq %rcx, %r9
 jbe .underflow
 subq %rcx, %r9
 btq $63, %r9
 jc .overflow
 orq %r8, %r9
 movq %r9, (%rdi)
.exflib_float_mul_h_end:
 movq %r11, %rsp
 popq %rdx
 popq %r14
 popq %r13
 popq %r12
 popq %rbp
 popq %rbx
 ret
.overestimate:
 xorq %rax, %rax
 notq %rax
 jmp .sign
.overflow:
 xorq %rcx, %rcx
 notq %rcx
 shrq $1, %rcx
 orq %rcx, %r8
 xorq %rax, %rax
.underflow:
 adcq $0, %rax
 movq %r8, (%rdi)
 jmp .exflib_float_mul_h_end
.zero:
 movq (%rdi), %rax
 movq (%rsi), %r8
 xorq %rax, %r8
 xorq %rax, %rax
 shrq $63, %r8
 shlq $63, %r8
 movq %r8, (%rdx)
 ret
